package net.raepple.plugin.popup.actions;

import net.raepple.plugin.XMLElementCountWizard;
import net.raepple.plugin.XMLProcessing;

import org.eclipse.core.resources.IFile;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;

public class CountElements implements IObjectActionDelegate
{
	private IFile xmlFile;

	/**
	 * Constructor for Action1.
	 */
	public CountElements()
	{
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart)
	{
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action)
	{
		XMLElementCountWizard wizard = new XMLElementCountWizard(xmlFile);		
		WizardDialog dialog = new WizardDialog(XMLProcessing.getDefault().getWorkbench().getActiveWorkbenchWindow().getShell(),wizard);
		dialog.create();
		dialog.open();			
	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection)
	{
		this.xmlFile = null;
		if (selection instanceof IStructuredSelection) {
			IStructuredSelection structuredSelection = (IStructuredSelection) selection;
			if (structuredSelection.size() == 1) {
				Object selectedResource = structuredSelection.getFirstElement();
				if (selectedResource instanceof IFile)
					this.xmlFile = (IFile) selectedResource;
			}
		}		
	}
	
	/**
	 * @return
	 */
	public IFile getXmlFile()
	{
		return xmlFile;
	}

}
